#include <iostream.h>
#include <string.h>
#include <stdlib.h>

/*
 * run this by typing 'cstring' and entering a line of text when prompted.
 * make sure the text has spaces in it (e.g. "my battery is flat")
 * this program breaks the text up into it's constituent words and
 * prints out each word along with it's length.
 * It only works on the first 20 words in the text - extend it or
 * better still make it work for any number of words. This will
 * cock it up if more than one space is between words: improve it!
 */

// prototypes
bool readText(char*, int);
int splitText(char*, char* [], int);
void writeWords(char* [], int);

#define MAX_WORDS 20  // pre-processor constants
#define MAX_TEXT 256

/*
 * entry point
 */
int main(int argc, char* argv[])
{
  char  text[MAX_TEXT];
  char* words[MAX_WORDS];

  if (!readText(text, MAX_TEXT)) {
    cerr << argv[0] << ": cannot understand input\n";
    exit(-1);
  }

  int nwords = splitText(text, words, MAX_WORDS);

  writeWords(words, nwords);

  return 0;
}

/*
 * get some input from the user
 */
bool readText(char* text, int maxLen)
{
  cout << "Type in a sentence and press return\n";

  cin.get(text, maxLen);

  return !(cin.rdstate() & ios::failbit); // check the stream state
}

/*
 * split the string into tokens (words) assuming
 * they are delimited by spaces
 */
int splitText(char* text, char* words[], int maxWords)
{
  int textLen = strlen(text);
  int nwords = 0;

  bool newWord = true;
  for (int i=0; i<textLen; i++) {
    if (newWord) {
      newWord = false;
      words[nwords++] = &text[i];
    }
    if (text[i] == ' ') {
      newWord = true;
      text[i] = '\0';
    }
  }

  return nwords;
}

/*
 * output each word and it's length
 */
void writeWords(char* words[], int nwords)
{
  for (int i=0; i<nwords; i++) {
    cout << "'" << words[i] << "' (len = " << strlen(words[i]) << ")\n";
  }
}