#include <iostream.h>
#include <stdlib.h>

/*
 * run this by typing "factorial <int>" where <int> is a positive integer
 * The program shows use of recursion... the factorial function just
 * keeps calling itself until the <int> has been reduced to zero, so
 * if <int> = N eventually the function returns N*(N-1)*(N-2)*...
 */

/*
 * function calls itself until n has been reduced to 0
 */
int factorial(int n)
{
  // alternative code using the tertiary '?' operator...
  // return (n > 0) ? n*factorial(n-1) : 1;

  if (n > 0) {
    return n*factorial(n-1);
  }
  else {
    return 1;
  }
}

/*
 * entry point
 */
int main(int argc, char* argv[])
{
  if (argc < 2) {
    cerr << "usage: " << argv[0] << " <integer>\n";
    exit(-1);
  }

  int n = atoi(argv[1]);

  cout << n << "! = " << factorial(n) << "\n";

  return 0;
}
