#include <iostream.h>
#include <stdlib.h>

struct myRecord {
  char* surname;
  char* firstName;
  int nDaysOff;
  float salary;
};

/*
 * function to output the contents of a 'struct myRecord'
 */
void writeRecord(struct myRecord* pMR)
{
  cout << pMR->surname
       << ", "
       << pMR->firstName
       << "; Days of: "
       << pMR->nDaysOff
       << "; Salary $"
       << pMR->salary
       << "\n";
}

/*
 * function to write out an array of 'struct myRecord' entries
 */
void writeRecords(const char* title, struct myRecord* array, int n)
{
  cout << "\n" << title << "\n";

  // this might be confusing but it shouldn't be...
  // define a pointer to a 'struct myRecord' and remember
  // that if we use ++ on a pointer it automatically will
  // move to the next data item, irrelevant of what data type
  struct myRecord* pMR = array;

  for (int i=0; i<n; i++) {
    writeRecord(pMR);  // note: pMR is already a pointer; no need for the '&'
    pMR++;
  }
}

/*
 * comparison function to sort records w.r.t. salary
 */
int cmpSalary(const void* e1, const void* e2)
{
  struct myRecord* pMR1 = (struct myRecord*)e1;
  struct myRecord* pMR2 = (struct myRecord*)e2;

  float salary1 = pMR1->salary;
  float salary2 = pMR2->salary;

  // sort salaries in descending order
  if (salary1 > salary2) {
    return -1;
  }
  else if (salary1 < salary2) {
    return 1;
  }
  else {
    return 0;
  }
}

/*
 * comparison function to sort records w.r.t. days off
 */
int cmpDaysOff(const void* e1, const void* e2)
{
  struct myRecord* pMR1 = (struct myRecord*)e1;
  struct myRecord* pMR2 = (struct myRecord*)e2;

  int nDaysOff1 = pMR1->nDaysOff;
  int nDaysOff2 = pMR2->nDaysOff;

  // sort days off in ascending order
  if (nDaysOff1 < nDaysOff2) {
    return -1;
  }
  else if (nDaysOff1 > nDaysOff2) {
    return 1;
  }
  else {
    return 0;
  }
}

/*
 * entry point
 */
int main(int argc, char* argv[])
{
  struct myRecord single;

  single.surname = "Heath";
  single.firstName = "Andy";
  single.nDaysOff = 364;
  single.salary = 1000.0;

  // write out this single record
  cout << "Just a single record:\n";
  writeRecord(&single);

  // make and initialise an array of 'struct myRecord' entries
  struct myRecord records[] = {
    { "Shakespeare", "Bill", 45,  3.5    },
    { "Franklin",    "Ben",  5,   200.3  },
    { "Gates",       "Bill", 0,   1.0e10 },
    { "Jackson",     "Mick", 100, 1.0e8  },
    { "Shairp",      "Ash",  -1,  1.0    }
  };

  // double-click 'sizeof' and press F1 (in VC++) to find out what it does
  int numberOfRecords = sizeof(records)/sizeof(records[0]);

  // sort the entries by salary and write out
  qsort(records, numberOfRecords, sizeof(struct myRecord), cmpSalary);
  writeRecords("Records sorted by salary:", records, numberOfRecords);

  // sort the records again, this time by days off
  qsort(records, numberOfRecords, sizeof(struct myRecord), cmpDaysOff);
  writeRecords("Records sorted by number of days off:", records, numberOfRecords);

  return 0;
}
